'**************************************************************************
'*                       Summaria Install
'*    
'*                       Copyright 1993 Chris Samaniego
'*
'**************************************************************************

'$DEFINE DEBUG  ''Define for script development/debugging

'$INCLUDE 'setupapi.inc'
'$INCLUDE 'msdetect.inc'

''Dialog ID's
CONST WELCOME       = 100
CONST ASKQUIT       = 200
CONST DESTPATH      = 300
CONST EXITFAILURE   = 400
CONST EXITQUIT      = 600
CONST EXITSUCCESS   = 700
CONST OPTIONS       = 800
CONST APPHELP       = 900
CONST BADPATH       = 6400

''Bitmap ID
CONST LOGO = 1

GLOBAL DEST$        ''Default destination directory.
GLOBAL OPTCUR$      ''Option selection from option dialog.
GLOBAL SRCDIR$      ''Source directory
GLOBAL WINDIR$      ''Window Directory
DECLARE SUB Install
DECLARE SUB Install2
DECLARE FUNCTION MakePath (szDir$, szFile$) AS STRING


INIT:
	CUIDLL$ = "mscuistf.dll"            ''Custom user interface dll
	HELPPROC$ = "FHelpDlgProc"          ''Help dialog procedure

	SetBitmap CUIDLL$, LOGO
	SetTitle "Exploring Ancient Cities Setup"

	SRCDIR$ = GetSymbolValue("STF_SRCDIR")
	szInf$ = GetSymbolValue("STF_SRCINFPATH")
	IF szInf$ = "" THEN
		szInf$ = GetSymbolValue("STF_CWDDIR") + "ancient.INF"
	END IF
	ReadInfFile szInf$

	OPTCUR$ = "1"
	DEST$ = "C:\QTPlayer"

	WINDIR$ = GetWindowsDir()

	SetAbout "Exploring Ancient Cities","Copyright (C) 1994 Sumeria" 

WELCOME:
	sz$ = UIStartDlg(CUIDLL$, WELCOME, "FInfoDlgProc", APPHELP, HELPPROC$)
	IF sz$ = "CONTINUE" THEN
		UIPop 1
	ELSE
		GOSUB ASKQUIT
		GOTO WELCOME
	END IF



OPTION:
	SetSymbolValue "RadioDefault", OPTCUR$
OPTL1:
	sz$ = UIStartDlg(CUIDLL$, OPTIONS, "FRadioDlgProc", APPHELP, HELPPROC$)
	OPTCUR$ = GetSymbolValue("ButtonChecked")

	IF sz$ = "CONTINUE" THEN
		UIPop(1)
	ELSEIF sz$ = "REACTIVATE" THEN
		GOTO OPTL1
	ELSE
		GOSUB ASKQUIT
		GOTO OPTION
	END IF

	IF OPTCUR$ = "1" THEN
		GOTO ICONONLY 
	END IF 

GETPATH:
	SetSymbolValue "EditTextIn", DEST$
	SetSymbolValue "EditFocus", "END"
GETPATHL1:
	sz$ = UIStartDlg(CUIDLL$, DESTPATH, "FEditDlgProc", APPHELP, HELPPROC$)
	DEST$ = GetSymbolValue("EditTextOut")

	IF sz$ = "CONTINUE" THEN
		IF IsDirWritable(DEST$) = 0 THEN
			GOSUB BADPATH
			GOTO GETPATHL1
		END IF
		UIPop 1
	ELSEIF sz$ = "REACTIVATE" THEN
		GOTO GETPATHL1
	ELSEIF sz$ = "BACK" THEN
		UIPop 1
		GOTO OPTION
	ELSE
		GOSUB ASKQUIT
		GOTO GETPATH
	END IF


	Install

	IF OPTCUR$ = "4" THEN
		GOTO QUIT 
	END IF 

ICONONLY:

	Install2



QUIT:
	ON ERROR GOTO ERRQUIT

	IF ERR = 0 THEN
		dlg% = EXITSUCCESS
	ELSEIF ERR = STFQUIT THEN
		dlg% = EXITQUIT
	ELSE
		dlg% = EXITFAILURE
	END IF
QUITL1:
	sz$ = UIStartDlg(CUIDLL$, dlg%, "FInfo0DlgProc", 0, "")
	IF sz$ = "REACTIVATE" THEN
		GOTO QUITL1
	END IF
	UIPop 1

	END

ERRQUIT:
	i% = DoMsgBox("Setup sources were corrupted, call product support at (415)904-0800", "Setup Message", MB_OK+MB_TASKMODAL+MB_ICONHAND)
	END



BADPATH:
	sz$ = UIStartDlg(CUIDLL$, BADPATH, "FInfo0DlgProc", 0, "")
	IF sz$ = "REACTIVATE" THEN
		GOTO BADPATH
	END IF
	UIPop 1
	RETURN



ASKQUIT:
	sz$ = UIStartDlg(CUIDLL$, ASKQUIT, "FQuitDlgProc", 0, "")

	IF sz$ = "EXIT" THEN
		UIPopAll
		ERROR STFQUIT
	ELSEIF sz$ = "REACTIVATE" THEN
		GOTO ASKQUIT
	ELSE
		UIPop 1
	END IF
	RETURN



'**
'** Purpose:
'**     Builds the copy list and performs all installation operations.
'** Arguments:
'**     none.
'** Returns:
'**     none.
'*************************************************************************
SUB Install STATIC


	CreateDir DEST$, cmoNone

	AddSectionFilesToCopyList "Options", SRCDIR$, DEST$
	CopyFilesInCopyList

	CreateProgmanGroup "QuickTime for Windows", "", cmoNone
	ShowProgmanGroup  "QuickTime for Windows", 1, cmoNone
	CreateProgmanItem "QuickTime for Windows", "Movie Player", MakePath(DEST$,"Player.exe"), "", cmoOverwrite
	CreateProgmanItem "QuickTime for Windows", "Picture Viewer",MakePath(DEST$,"Viewer.exe"), "", cmoOverwrite
	CreateProgmanItem "QuickTime for Windows", "Readme","write " + MakePath(DEST$,"readme.wri"), "", cmoOverwrite

END SUB

SUB Install2 STATIC

	ClearCopyList
	AddSectionFilesToCopyList "Icons", SRCDIR$, WINDIR$
	CopyFilesInCopyList

	CreateProgmanGroup "Ancient Cities", "", cmoVital
	ShowProgmanGroup  "Ancient Cities", 1, cmoVital
	CreateProgmanItem "Ancient Cities", "Exploring Ancient Cities", MakePath(SrcDir$,"cities.exe"), MakePath(WINDIR$,"ancient.ico"), cmoOverwrite
	CreateProgmanItem "Ancient Cities", "Read Me","Write " + MakePath(SrcDir$,"creadme.wri"), "", cmoOverwrite

END SUB



'**
'** Purpose:
'**     Appends a file name to the end of a directory path,
'**     inserting a backslash character as needed.
'** Arguments:
'**     szDir$  - full directory path (with optional ending "\")
'**     szFile$ - filename to append to directory
'** Returns:
'**     Resulting fully qualified path name.
'*************************************************************************
FUNCTION MakePath (szDir$, szFile$) STATIC AS STRING
	IF szDir$ = "" THEN
		MakePath = szFile$
	ELSEIF szFile$ = "" THEN
		MakePath = szDir$
	ELSEIF MID$(szDir$, LEN(szDir$), 1) = "\" THEN
		MakePath = szDir$ + szFile$
	ELSE
		MakePath = szDir$ + "\" + szFile$
	END IF
END FUNCTION

